%{
/***************************************************************************
 *   Copyright (C) 2005 by SukkoPera                                       *
 *   sukkopera@gmail.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#define __USE_GNU
#include <string.h>

#define YYSTYPE char *

#include "cmp_bison.h"
%}

%option yylineno

%x rom

ws		[ \t\n\r]+
string_bl	"\""[^\"\n\r]*"\""
string_nobl	[^ :;()\"\n\r]+
other		"("|")"

%%

<*>{ws}			{;}

"clrmamepro"			{return (CLRMAMEPRO);}
"category"			{return (CATEGORY);}
"version"			{return (VERSION);}
"author"			{return (AUTHOR);}
"game"				{return (GAME);}
"name"				{return (NAME);}
"description"			{return (DESCRIPTION);}
"size"				{return (SIZE);}
"crc"				{return (CRC);}
"md5"				{return (MD5);}
"rom"				{return (ROM);}
				 
{string_bl}			{yylval = strndup (yytext + 1, yyleng - 2);	/* Copy trimming away quotes */
				 return (STRING);}
{string_nobl}			{yylval = strdup (yytext);
				 return (STRING);}
				 
<*>{other}			{return (yytext[0]);}

				 
<<EOF>>				{return (EOF);}

%%

int yywrap (void) {
	return (1);
}
/*
int main (void) {
       int r;

        while ((r = yylex ()) != 700)
                printf ("Returned %d for |%s|\n", r, yytext);

        return (1);

}*/
