/***************************************************************************
 *   Copyright (C) 2006 by SukkoPera                                       *
 *   sukkopera@gmail.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <glib.h>
#include "romentry.h"
#include "file.h"

typedef struct {
	char *filename;
	
	/* CREDITS section */
	char *author;
	char *data_version;
	char *comment;

	/* DAT section */
	char *dat_format;
	char *plugin;
	gboolean split;
	gboolean merge;

	/* EMULATOR section */
	char *emulator;
	char *emulator_version;

	/* Our data */
	GData *roms;
	guint32 roms_no;
	guint32 found_roms;
} datfile;


datfile *datfile_new_from_filename_rc (char *filename);
datfile *datfile_new_from_filename_cmp (char *filename);
datfile *datfile_new_from_filename (char *filename);

romentry *datfile_find (datfile *rcf, filez *f);
