/***************************************************************************
 *   Copyright (C) 2005 by SukkoPera                                       *
 *   sukkopera@gmail.com                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef FILEZ_H_INCLUDED
#define FILEZ_H_INCLUDED

#include <stdio.h>
#include <glib.h>

#define LEN_CRC32 8
#define LEN_SHA1 40
#define LEN_MD5 32

#define READBUF_SIZE 1024

typedef struct {
	char *filename;
	guint32 filesize;
	char *parent_archive;		//!< If the file is contained in an archive, the archive name goes here.

	char crc32[LEN_CRC32 + 1];
	char md5[LEN_MD5 + 1];
	char sha1[LEN_SHA1 + 1];
} filez;


/* Prototypes */
filez *file_new (char *filename);
filez *file_new_archived (char *filename, char *archive, guint32 filesize);
void file_destroy (filez *f);
void file_compute_sums (filez *f);

#endif
