/***************************************************************************
 *   Copyright (C) 2006 by SukkoPera                                       *
 *   sukkopera@gmail.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#include <glib.h>
#include "romentry.h"

romentry *romentry_new (char *name, char *description, char *filename, char *filesize, char *crc32) {
	romentry *out;

	out = g_new0 (romentry, 1);
	g_assert (out);

	out -> name = g_strdup (name);
	out -> description = g_strdup (description);
	out -> filename = g_strdup (filename);
	if (filesize)
		sscanf (filesize, "%d", &(out -> filesize));
// 	if (crc32)
// 		sscanf (crc32, "%x", &(out -> crc32));
	out -> crc32 = g_ascii_strdown (crc32, -1);

// 	g_debug ("Created ROM entry: %s/%x", name, out -> crc32);

	return (out);
}
