/***************************************************************************
 *   Copyright (C) 2006 by SukkoPera                                       *
 *   sukkopera@gmail.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ZIPFILE_H_INCLUDED
#define ZIPFILE_H_INCLUDED

#include <glib.h>
#include "mz_zip.h"

typedef struct {
	char *filename;
	char *password;
	int compress_level;	/* 0-9 */

	zipFile zf_int;
	void *buffer;
	guint32 bufsize;
} zipfile;


zipfile *zipfile_new (char *filename);
zipfile *zipfile_destroy (zipfile *zf);
int zipfile_extract_all (zipfile *zf, char *destdir, int nofullpath, int overwrite);
int zipfile_extract_one (zipfile *zf, char *file_to_extract, char *destdir, gboolean nofullpath, gboolean overwrite);
void zipfile_dump (zipfile *zf);
gboolean zipfile_begin_add (zipfile *zf);
int zipfile_add (zipfile *myzf, char *srcfile, char *filenameinzip, char *filecomment);
gboolean zipfile_end_add (zipfile *zf);
GList *zipfile_get_filelist (zipfile *zf);

#endif
